﻿using Bots.Grind;
using CommonBehaviors.Actions;
using Styx;
using Styx.CommonBot;
using Styx.CommonBot.Coroutines;
using Styx.CommonBot.POI;
using Styx.CommonBot.Profiles;
using Styx.TreeSharp;
using Styx.WoWInternals.WoWObjects;
using System.Collections.Generic;
using System.Threading.Tasks;


namespace SecondaryBot
{
    public class SecondaryBot : BotBase
    {
        private Composite _root;
        private static Composite _combatBehavior;
        private static Composite _deathBehavior;

        public override string Name
        {
            get { return "SecondaryBot"; }
        }

        public override PulseFlags PulseFlags
        {
            get { return PulseFlags.All; }
        }

        public override Composite Root
        {
            get { return _root ?? (_root = new ActionRunCoroutine(ctx => CreateRootBehavior())); }
        }

        static Composite CombatBehavior
        {
            get { return _combatBehavior ?? (_combatBehavior = LevelBot.CreateCombatBehavior()); }
        }

        static Composite DeathBehavior
        {
            get { return _deathBehavior ?? (_deathBehavior = LevelBot.CreateDeathBehavior()); }
        }

        public async static Task CreateRootBehavior()
        {
            if (await DeathBehavior.ExecuteCoroutine())
                return;

            if (await CombatBehavior.ExecuteCoroutine())
                return;
        }
    }
}
